diff --git a/gdb/doc/gdb.texinfo b/gdb/doc/gdb.texinfo
index 2f5b4bb4c61a..8a83a2ef8dd4 100644
--- a/gdb/doc/gdb.texinfo
+++ b/gdb/doc/gdb.texinfo
@@ -154,7 +154,7 @@ software in general.  We will miss him.
 * Configurations::              Configuration-specific information
 * Controlling GDB::             Controlling @value{GDBN}
 * Extending GDB::               Extending @value{GDBN}
-* Interpreters::		Command Interpreters
+* Interpreters::                Command Interpreters
 * TUI::                         @value{GDBN} Text User Interface
 * Emacs::                       Using @value{GDBN} under @sc{gnu} Emacs
 * GDB/MI::                      @value{GDBN}'s Machine Interface.
@@ -182,16 +182,16 @@ software in general.  We will miss him.
                                 @value{GDBN}
 * Operating System Information:: Getting additional information from
                                  the operating system
-* Trace File Format::		GDB trace file format
+* Trace File Format::           GDB trace file format
 * Index Section Format::        .gdb_index section format
 * Debuginfod::                  Download debugging resources with @code{debuginfod}
-* Man Pages::			Manual pages
-* Copying::			GNU General Public License says
+* Man Pages::                   Manual pages
+* Copying::                     GNU General Public License says
                                 how you can copy and share GDB
 * GNU Free Documentation License::  The license for this documentation
 * Concept Index::               Index of @value{GDBN} concepts
 * Command and Variable Index::  Index of @value{GDBN} commands, variables,
-                                  functions, and Python data types
+                                functions, and Python data types
 @end menu
 
 @end ifnottex
@@ -6981,11 +6981,11 @@ or while being stepped), all other threads in the program are also stopped by
 you examine the stopped thread in the debugger.
 
 @menu
-* All-Stop Mode::		All threads stop when GDB takes control
-* Non-Stop Mode::		Other threads continue to execute
-* Background Execution::	Running your program asynchronously
-* Thread-Specific Breakpoints::	Controlling breakpoints
-* Interrupted System Calls::	GDB may interfere with system calls
+* All-Stop Mode::               All threads stop when GDB takes control
+* Non-Stop Mode::               Other threads continue to execute
+* Background Execution::        Running your program asynchronously
+* Thread-Specific Breakpoints:: Controlling breakpoints
+* Interrupted System Calls::    GDB may interfere with system calls
 * Observer Mode::               GDB does not alter program behavior
 @end menu
 
@@ -9086,7 +9086,7 @@ prefer to use Emacs facilities to view source; see @ref{Emacs, ,Using
 * Search::                      Searching source files
 * Source Path::                 Specifying source directories
 * Machine Code::                Source and machine code
-* Disable Reading Source::	Disable Reading Source Code
+* Disable Reading Source::      Disable Reading Source Code
 @end menu
 
 @node List
@@ -22855,7 +22855,7 @@ configuration of @value{GDBN}; use @code{help target} to list them.
 @menu
 * Connecting::                  Connecting to a remote target
 * File Transfer::               Sending files to a remote system
-* Server::	                Using the gdbserver program
+* Server::                      Using the gdbserver program
 * Remote Configuration::        Remote configuration
 * Remote Stub::                 Implementing a remote stub
 @end menu
@@ -24431,13 +24431,13 @@ This section describes details specific to particular native
 configurations.
 
 @menu
-* BSD libkvm Interface::	Debugging BSD kernel memory images
+* BSD libkvm Interface::        Debugging BSD kernel memory images
 * Process Information::         Process information
 * DJGPP Native::                Features specific to the DJGPP port
-* Cygwin Native::		Features specific to the Cygwin port
+* Cygwin Native::               Features specific to the Cygwin port
 * Hurd Native::                 Features specific to @sc{gnu} Hurd
-* Darwin::			Features specific to Darwin
-* FreeBSD::			Features specific to FreeBSD
+* Darwin::                      Features specific to Darwin
+* FreeBSD::                     Features specific to FreeBSD
 @end menu
 
 @node BSD libkvm Interface
@@ -25379,7 +25379,7 @@ acceptable commands.
 * ARM::                         ARM
 * BPF::                         eBPF
 * M68K::                        Motorola M68K
-* MicroBlaze::			Xilinx MicroBlaze
+* MicroBlaze::                  Xilinx MicroBlaze
 * MIPS Embedded::               MIPS Embedded
 * OpenRISC 1000::               OpenRISC 1000 (or1k)
 * PowerPC Embedded::            PowerPC Embedded
@@ -28713,7 +28713,7 @@ This creates alias @samp{spe} of the command @samp{set print elements}.
 @end smallexample
 
 @menu
-* Command aliases default args::	Default arguments for aliases
+* Command aliases default args::        Default arguments for aliases
 @end menu
 
 @node Command aliases default args
@@ -28842,9 +28842,9 @@ Note that loading of this script file also requires accordingly configured
 @code{auto-load safe-path} (@pxref{Auto-loading safe path}).
 
 @menu
-* objfile-gdbdotext file::		The @file{@var{objfile}-gdb.@var{ext}} file
-* dotdebug_gdb_scripts section::	The @code{.debug_gdb_scripts} section
-* Which flavor to choose?::		Choosing between these approaches
+* objfile-gdbdotext file::              The @file{@var{objfile}-gdb.@var{ext}} file
+* dotdebug_gdb_scripts section::        The @code{.debug_gdb_scripts} section
+* Which flavor to choose?::             Choosing between these approaches
 @end menu
 
 @node objfile-gdbdotext file
@@ -48272,7 +48272,7 @@ with @code{elfutils}, starting with version 0.178.  See
 regarding @code{debuginfod}.
 
 @menu
-* Debuginfod Settings::		Configuring debuginfod with @value{GDBN}
+* Debuginfod Settings::         Configuring debuginfod with @value{GDBN}
 @end menu
 
 @node Debuginfod Settings
diff --git a/gdb/doc/python.texi b/gdb/doc/python.texi
index ad929ee14930..7208af3ee7d7 100644
--- a/gdb/doc/python.texi
+++ b/gdb/doc/python.texi
@@ -196,7 +196,7 @@ optional arguments while skipping others.  Example:
 * Pretty Printing API::         Pretty-printing values.
 * Selecting Pretty-Printers::   How GDB chooses a pretty-printer.
 * Writing a Pretty-Printer::    Writing a Pretty-Printer.
-* Type Printing API::		Pretty-printing types.
+* Type Printing API::           Pretty-printing types.
 * Frame Filter API::            Filtering Frames.
 * Frame Decorator API::         Decorating Frames.
 * Writing a Frame Filter::      Writing a Frame Filter.
@@ -225,7 +225,7 @@ optional arguments while skipping others.  Example:
 * Lazy Strings In Python::      Python representation of lazy strings.
 * Architectures In Python::     Python representation of architectures.
 * Registers In Python::         Python representation of registers.
-* Connections In Python::	Python representation of connections.
+* Connections In Python::       Python representation of connections.
 * TUI Windows In Python::       Implementing new TUI windows.
 * Disassembly In Python::       Instruction Disassembly In Python
 @end menu